Mirrors are web and FTP servers that mirror repos from the official repo web server.

# Usage
To use a mirror with `mp`, change the repo URI for the target repo in your `mp`
configuration file (`/etc/mp/cfg`). 

### Creating a mirror
To create a mirror you can use the `matter-mirror` tool. This tool is included 
with the `tools` repository. To install it [see the project READMDE](https://git.matterlinux.xyz/Matter/tools#installation).

After installing `matter-mirror`, specify an URI and an output directory (files will be downloaded
into the output directory). For example to mirror the `base` repo from 
`https://pkgs.matterlinux.xyz/base` to `base_mirror` directory:
```
$ mkdir base_mirror
$ matter-mirror -u https://pkgs.matterlinux.xyz/base -o base_mirror 
```

To serve the mirror, you can setup a web server such as `nginx`, or you can setup a FTP 
server such as `pure-ftpd`.

You will mostly likely want to update your mirror every once in a while. To do so you can 
create a cron job. For example to update your mirror every day at 00:00, you can add the
following entry to your `/etc/crontab`:
```
0 0     * * *   <user>    matter-mirror -u <url> -o <output dir path> 
```

# List
This section contains information about different MatterLinux repo and mirros 
that you can use. To add your mirror to this list get in contact with the maintainer/developers.

> **Note**
>
> Official mirrors are **ALWAYS** signed with the `F9E70878C2FB389AEC2BA34CA3654DF5AD9F641D`
> fingerprint (belongs to the maintainer, ngn). If syncing with a mirror tells you otherwise, then
> **DO NOT USE THAT MIRROR** and report it to the maintainer/developers in order to remove it 
> from the list.

### Official repos
| Repo    | URI                                    | Location    |
| ------- | -------------------------------------- | ----------- |
| base    | `https://pkgs.matterlinux.xyz/base`    | 🇹🇷 Turkey |
| desktop | `https://pkgs.matterlinux.xyz/desktop` | 🇹🇷 Turkey |

### Mirrors
Currently there are no available mirrors.
